var $j = jQuery.noConflict(); 

jQuery.fn.calendaric = function (callback) {
  $j.calendaric(this, callback);
  return this;
};

jQuery.calendaric = function (container, callback) {
  var container = $j(container).get(0);
  return container.calendaric || (container.calendaric = new jQuery._calendaric(container, callback));
}

jQuery._calendaric = function (container, callback) {
  // Store calendaric object
  var fb = this;

  var month_ru = ['Январь', 'Февраль', 'Март', 'Апрель', 'Май', 'Июнь', 'Июль', 'Август', 'Сентябрь', 'Октябрь', 'Ноябрь', 'Декабрь'];
  var date = new Date();
  var month = date.getMonth();
  var year = date.getFullYear();
  var dayw = date.getDay();
  var dayn = date.getDate();

  fb.num = 0;
  fb.checkY = year;
  fb.checkM = month;
  fb.checkD = [];
  fb.caltable = [];
  fb.globhash3 = '{2010:{9:{1:"1",2:"2",20:"20",21:"21",25:"25"},10:{1:"1"}}}';

  // Insert markup
  $j(container).html('<div class="calendaric"><div id="datapick2"><table id="caltab"><tr><td colspan="7" id="calyear"></td></tr>\
			<tr><td id="lastmonth">&laquo;</td><td colspan="5" id="calmonth"></td><td id="prevmonth">&raquo;</td></tr>\
			<tr><td>Mon</td><td>Tue</td><td>Wed</td><td>Thu</td><td>Fri</td><td>Sat</td><td>Sun</td></tr></table>\
                        <table id="calday2" class="tb'+year+month+'"></table></div></div>');
  var e = $j('.calendaric', container);
  fb.calYear = $j('#calyear', container);   
  fb.calMonth = $j('#calmonth', container);
  fb.calDay = $j('#calday2', container);

  /**
   * Link to the given element(s) or callback.
   */
  fb.linkTo = function (callback) {
    // Unbind previous nodes
    //if (typeof fb.callback == 'object') { $j(fb.callback).unbind('keyup', fb.updateValue); }

    // Reset globhash
    fb.globhash2 = null;
    fb.globhash = null;
    fb.calYear.val("");
    fb.calMonth.val("");	
    fb.chYear = false;
    fb.chMonth = false;
    fb.chDay = false;

    // Bind callback or elements
    if (typeof callback == 'function') { fb.callback = callback; }
    else if (typeof callback == 'object' || typeof callback == 'string') {
	fb.callback = $j(callback);
	//fb.callback.bind('keyup', fb.updateValue);
	if (fb.callback.get(0).value) {	fb.setTableDay(fb.callback.get(0).value); }
    }
    return this;
  }

  /////////////////////////////////////////////////////
  fb.updateValue = function (event) {
    if (this.value && this.value != fb.globhash2) {
        fb.setTableDay(this.value);
    }
  }

  fb.setTableDay = function(hash) {
    var unpack = fb.unpack(hash);
    if ((fb.calYear.val() != unpack.year) || (fb.calMonth.val() != unpack.month + 1) || fb.chDay) {	
	fb.updateDisplay(unpack);
    }
    return this;
  }

  fb.unpack = function(hash) {
	fb.chYear = false;
	fb.chMonth = false;
	fb.globhash2 = hash;
	fb.globhash = eval("(" + hash + ")");
	for (var keyY in fb.globhash) {
		if (keyY == fb.checkY) { 
			fb.chYear = true;
			var tmpHm = fb.globhash[keyY];
			for (var keyM in tmpHm) {
				if (keyM == (fb.checkM + 1)) { 
					fb.chMonth = true;
					fb.checkD = [];
					var tmpHd = tmpHm[keyM];
					for (var keyD in tmpHm[keyM]) {fb.checkD.push(keyD)};
				}
			}
		}
	}
	if (!fb.chYear) {
		fb.globhash[fb.checkY]  = {};
		//fb.globhash[fb.checkY][fb.checkM] = {};
	}
	if (!fb.chMonth) {
		fb.globhash[fb.checkY][fb.checkM + 1] = {};
	}
	return ({year:fb.checkY,month:fb.checkM,day:fb.checkD});  
   }

  /////////////////////////////////////////////////////
  fb.updateDisplay = function (unpack) {
	fb.calYear.html(unpack.year);
	fb.calYear.val(unpack.year);
	fb.calMonth.html(month_ru[unpack.month]);
	fb.calMonth.val(unpack.month + 1);
	fb.chDay = false;
	fb.caltable = fb.inserttable(unpack.year, unpack.month);
	fb.calDay.html(fb.DayToTable(fb.caltable));
	fb.setOutCh(unpack.year, unpack.month, unpack.day);
	if (unpack.month > month || unpack.year > year) {
		$j('#lastmonth', e).html('&laquo;');
	}
	else {
		$j('#lastmonth', e).html('');
	}
	$j('*', e).click(fb.click);
    // Linked elements or callback
    if (typeof fb.callback == 'object') {

      // Change linked value
      $j(fb.callback).each(function() {
	if (this.value && this.value != fb.globhash2) {
	  this.value = fb.globhash2;
	}
      });
    }
    else if (typeof fb.callback == 'function') { fb.callback.call(fb, fb.globhash); }
  }


  /////////////////////////////////////////////////////
  fb.checked = function () {
        var tmpCh = '';
        var tmpD = '';
	$j('input:checkbox').filter(':checked').each(function(){
	if (this.value == "yes") { 
		tmpD = this.name;
		tmpD = parseInt(tmpD.substr(2 - tmpD.length));
		tmpCh += tmpD+',';			 
		}
	});
  return (tmpCh.substr(0,tmpCh.length-1))|| ('[0]');
  }

  fb.checkmonth = function () {
  return $j('#calmonth', e).val() || month + 1;
  }  

  fb.checkyear = function () {
  return $j('#calyear', e).val() || year;
  }

  /////////////////////////////////////////////////////
  fb.inserttable = function (y, m) {
	var tmpArr = [];
	var dayofmonth = 32 - new Date(y,m,32).getDate();
	var day_count = 1;
	fb.num = 0;
	var tmpB = false;
	var dayofweek = new Date(y,m,1).getDay();
	for(i = 1; i <= 7; i++)
		{
		if(dayofweek == i) {tmpB = true;}
		if (tmpB)
			{
			tmpArr[i-1] = day_count;
			day_count++;
			}
		else { tmpArr[i-1] = ""; }
		}
	var tmpI = 0;
	while(true)
	{
		fb.num++;
		for(x = 1; x <= 7; x++)
		{
			tmpI = fb.num*7+(x-1);
			tmpArr[tmpI] = day_count;
			day_count++;
			if(day_count > dayofmonth) break;
		}
		if(day_count > dayofmonth) break;
	}
	return (tmpArr);
  }

  /////////////////////////////////////////////////////
  fb.DayToTable = function (caltable) {
	var tmpHTML = '';
	var tmpI = 0;
	var tmpY = 0;
	for(y = 0; y <= fb.num; y++) {
		tmpHTML += '<tr>';
		for(k = 0; k < 7; k++) {
			tmpI = (y * 7)+ k;
			if((caltable[tmpI] != "")&&(caltable[tmpI])) {
				if(k  == 5 || k == 6 ) {tmpHTML += '<td class="calday">\
<input class="checkbox2" type="checkbox" value="yes" id="cd'+caltable[tmpI]+'" name\
="cd'+caltable[tmpI]+'" /><font color=red>'+caltable[tmpI]+'</font></td>';}
					else {tmpHTML += '<td class="calday">\
<input class="checkbox2" type="checkbox" value="yes" id="cd'+caltable[tmpI]+'" name\
="cd'+caltable[tmpI]+'" />'+caltable[tmpI]+'</td>';}
        				}
        		else {tmpHTML += '<td class="caloutday">&nbsp;</td>'; tmpY++;}
			}
		tmpHTML += '</tr>';
	}
	return tmpHTML;
  }

  /////////////////////////////////////////////////////
  fb.setOutCh = function (Y, M, arrCheckB) {
        var tmpCh = '';
        var tmpD = '';
        $j('input:checkbox').each(function(){
                tmpD = this.name;
                tmpD = parseInt(tmpD.substr(2 - tmpD.length));
		if ((Y == year) && (M == month)) {
			if ((tmpD) < dayn) { $j(this).parent().addClass("caldayout"); }
			//if ((tmpD) < dayn) { $j(this).parent().addClass("caldayout"); $j(this).attr("disabled","disabled"); }		
		}
		for ( var key in arrCheckB ) { if (tmpD == arrCheckB[key] ) $j(this).attr("checked", "checked"); }
	});
  }

  /////////////////////////////////////////////////////
  /**
   * Mouseup handler
   */
  fb.mouseup = function () {
    $j(document).unbind('mouseup', fb.mouseup);
  }

/////////////////////////////////////////////////////
function replacer(key, value) {
    if (typeof value === 'number' && !isFinite(value)) {
        return value;
    }
    return value;
}

  /////////////////////////////////////////////////////
  fb.click = function(event) {
	fb.chDay = false;
      if ( $j(this).attr("class") == "checkbox2") {
	fb.chDay = true;
	var tmpD = $j(this).attr("id").substr(2);
	if ( $j(this).attr("checked") ) {
		fb.globhash[fb.checkY][fb.checkM + 1][tmpD] = tmpD;
	}
	else {
		delete fb.globhash[fb.checkY][fb.checkM + 1][tmpD];
	}
	fb.globhash2 = JSON.stringify(fb.globhash);
	//alert(JSON.stringify(fb.globhash));
	fb.setTableDay(fb.globhash2);
      }
      if ( $j(this).attr("id") == "lastmonth") {
	var tmpY = fb.calYear.val();
	var tmpM = fb.calMonth.val() - 1;
	if ( tmpY > year || tmpM > month) {
		if (tmpM == 0) { tmpY--; tmpM = 11;}
		else { tmpM--; }
		fb.checkY = tmpY;
		fb.checkM = tmpM;
		fb.checkD = [];
		fb.caltable = [];
		fb.setTableDay(fb.globhash2);
	}
      }
      if ( $j(this).attr("id") == "prevmonth") {
        var tmpY = fb.calYear.val();
	var tmpM = fb.calMonth.val() - 1;
	if (tmpM == 11) { tmpY++; tmpM = 0;}
	else { tmpM++; }
	fb.checkY = tmpY;
	fb.checkM = tmpM;
	fb.checkD = [];
	fb.caltable = [];
	fb.setTableDay(fb.globhash2);
      }
      return true;
  }


  // Init caltable
  //fb.setTableDay({year:{month:{}}});  

  // Set linked elements/callback
  if (callback) {
    fb.linkTo(callback);
  }

}

