<?php

//---------------------------------------------------------------------------------
// mm_widget_calendaric
//---------------------------------------------------------------------------------
function mm_widget_calendaric($fields, $roles='', $templates='') {
	global $modx, $content, $mm_fields;
	$e = &$modx->Event;

$year = date('Y');
$month = date('n');
$default = '{'.$year.':{'.$month.':{}}}';

	if (useThisRule($roles, $templates)) {

		$output = '';
		// if we've been supplied with a string, convert it into an array
		$fields = makeArray($fields);
		// Which template is this page using?
		if (isset($content['template'])) {
			$page_template = $content['template'];
		} else {
			// If no content is set, it's likely we're adding a new page at top level. 
			// So use the site default template. This may need some work as it might interfere with a default template set by MM?
			$page_template = $modx->config['default_template']; 
		}
		
		// Does this page's template use any of these TVs? If not, quit.
		$tv_count = tplUseTvs($page_template, $fields);
		if ($tv_count  === false) {
			return;
		}
		
		// Insert some JS  and a style sheet into the head
		$output .= "//  -------------- Calendar widget include ------------- \n";
		$output .= includeJs($modx->config['base_url'] .'assets/plugins/managermanager/widgets/calendaric/calendaric.js');
		$output .= includeCss($modx->config['base_url'] .'assets/plugins/managermanager/widgets/calendaric/calendaric.css');

                // Do something for each of the fields supplied
		foreach ($fields as $tv) {

			// If it's a TV, we may need to map the field name, to what it's ID is.
			// This can be obtained from the mm_fields array
			$tv_id = $mm_fields[$tv]['fieldname'];			

	$output .= ' 
	// ----------- Calendar widget for  '.$tv_id.'  --------------
	$j("#'.$tv_id.'").css("display", "none"); 
	//$j("#'.$tv_id.'").css("background-image","none");
	$j("#'.$tv_id.'").after(\'<div id="calendar'.$tv_id.'"></div>\');
	if ($j("#'.$tv_id.'").val() == "") { $j("#'.$tv_id.'").val("'.$default.'"); }
	$j("#calendar'.$tv_id.'").calendaric("#'.$tv_id.'");
	$j("#calendar'.$tv_id.'").mouseup( function() { // mark the document as dirty, or the value wont be saved
		$j("#'.$tv_id.'").trigger("change");
					   });
		';
		}
	$e->output($output . "\n");
	}
}
?>
